﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="MarkerWithLabel.aspx.cs" Inherits="MS_OSPFM.MarkerWithLabel" %>
<%@ Register Assembly="WebEdition" Namespace="ThinkGeo.MapSuite.WebEdition" TagPrefix="cc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title></title>
          <script type="text/javascript">
              //Marker with Pushpin variables
              var simpleMarkerOverlay = null;
              var tgMap = null;
              var addMode = false;
              var markerId = 1;
              var chkDblClicked = 0;

              //MT variables
              var measureLineControl;
              var map2;
              var displayLayer;
			  
              //Select features  variables
			  var shapeOverlay = null;
              var currentFeature = null;
              var styleRed = null;


              var OnMapCreated = function(map) {
              //Marker with Pushpin  
              tgMap = map;
              if (simpleMarkerOverlay == null) {
                  simpleMarkerOverlay = new OpenLayers.Layer.Markers("SimpleMarkerOverlay");
                  map.addLayer(simpleMarkerOverlay);
              }

              //MT  
                  displayLayer = new OpenLayers.Layer.Vector('displayLayer');
                  displayLayer.styleMap.styles["default"].defaultStyle.strokeColor = "Dark Blue";
                  displayLayer.styleMap.styles["default"].defaultStyle.strokeWidth = "3";

                  map.addLayer(displayLayer);
                  tgMap = map;

                  measureLineControl = new OpenLayers.Control.Measure(OpenLayers.Handler.Path, { persist: true });

                  measureLineControl.events.on({
                      "measure": handleMeasurementCompleted,
                      "measurepartial": handleMeasurements
                  });

                  map.addControl(measureLineControl);

				
				//Select features on map
				shapeOverlay = new OpenLayers.Layer.Vector({ style: { fillColor: 'red'} });
                map.addLayer(shapeOverlay);

                styleRed = {
					strokeColor: "#00FFFF",
                    strokeWidth: 4,
                    strokeDashstyle: "solid",
                    pointRadius: 6,
                    fillColor: "#00FFFF"
                };
	  
              }

            var linkOver = function(obj) {
                if (shapeOverlay != null) {
                    currentFeature = new OpenLayers.Format.WKT().read(obj.getAttribute('wkt'));
                    currentFeature.style = styleRed;
                    shapeOverlay.addFeatures([currentFeature]);
                }
            };
            var linkOut = function() {
                if (shapeOverlay && currentFeature) {
                    shapeOverlay.destroyFeatures([currentFeature]);
                }
            };    


              function AddLabel(e) {
                  if (document.getElementById('isAddLabel').value == 'true') {
                      var pixel = new OpenLayers.Pixel(e.x, e.y);
                      var lonlat = tgMap.getLonLatFromPixel(pixel);
                      AddEnterLabel(lonlat);
                  }
              }

              function AddEnterLabel(lonlat) {

                  var size = new OpenLayers.Size(15, 17);
                  var offset = new OpenLayers.Pixel(-(size.w / 2), -size.h);
                  var icon = new OpenLayers.Icon('theme/default/img/marker_blue.gif', size, offset);
                  var marker = new OpenLayers.Marker(lonlat, icon);
                  marker.id = markerId;

                  chkDblClicked = 0;
                  marker.events.register('dblclick', marker, function() {

                 if (document.getElementById('isRemoveMarker').value == 'true') {
                      simpleMarkerOverlay.removeMarker(this);
                      RemoveRelatedPopup(this.id);
                      chkDblClicked = 1;
                      //alert(chkDblClicked);
                      }
                  });

                  if (chkDblClicked == 0) {
                      simpleMarkerOverlay.addMarker(marker);

                      var content = "<input type='text' style='background-color: #FFFFCC; border-width: 0px; font-family: Arial; font-size: small; font-weight: bold; width:60px; color: #0000FF'></input>";
                      var popup = new OpenLayers.Popup("inputText",
                   lonlat,
                   new OpenLayers.Size(200, 200),
                   content,
                   false);

                      popup.id = markerId;
                      popup.backgroundColor = 'Transparent';
                      tgMap.addPopup(popup);
                      markerId += 1;
                  }
              }

              function RemoveRelatedPopup(markerId) {

                  if (tgMap.popups.length > 0) {

                      for (var index = 0; index < tgMap.popups.length; index++) {
                          if (tgMap.popups[index].id == markerId) {
                              tgMap.removePopup(tgMap.popups[index]);
                          }
                      }
                  }
              }

              function SetFlag() {
                  if (document.getElementById('isAddLabel').value == 'false') {
                      document.getElementById('isAddLabel').value = 'true';
                      document.getElementById('isRemoveMarker').value = 'false';
                      chkDblClicked == 0;  
                  }
              }

              function SetRemoveFlag() {
                  if (document.getElementById('isRemoveMarker').value == 'false') {
                      document.getElementById('isAddLabel').value = 'false';
                      document.getElementById('isRemoveMarker').value = 'true';
                  }
              }

              function activate() {
                  //alert(measureLineControl);
                  measureLineControl.activate();
                  document.getElementById('isAddLabel').value = 'false';
                  document.getElementById('isRemoveMarker').value = 'false';
                  
                  var layers = tgMap.getLayersByClass('OpenLayers.Layer.Vector');
                  for (var i = 0; i < layers.length; i++) {
                      layers[i].div.style.zIndex = 10000;
                  }
              }

              function deactivate() {
                  measureLineControl.deactivate();
              }

              function handleMeasurements(event) {
                  //alert('2');
                  var geometry = event.geometry;
                  var units = event.units;
                  //alert(units);
                  var order = event.order;
                  var measure = event.measure;
                  var miles;
                  if (units == 'm') {
                      miles = measure * 0.000621371192;
                  }
                  else {
                      miles = measure * 0.621371192;
                  }
                  var feets = miles * 5280;

                  var feets1 = addCommas(feets.toFixed(2));
                  var miles1 = addCommas(miles.toFixed(2));

                  var element = document.getElementById('output');
                  var out = "";
                  if (order == 1) {
                      out += "Distance: " + feets1 + " Feet (" + miles1 + " Miles)";
                  } else {
                      out += "Distance: " + feets1 + " Feet (" + miles1 + " Miles)" + "<sup>2</" + "sup>";
                  }
                  element.innerHTML = out;      //Distance: 2,322,323 Feet (3,450 Miles)
              }

              function addCommas(nStr) {
                  nStr += '';
                  x = nStr.split('.');
                  x1 = x[0];
                  x2 = x.length > 1 ? '.' + x[1] : '';
                  var rgx = /(\d+)(\d{3})/;
                  while (rgx.test(x1)) {
                      x1 = x1.replace(rgx, '$1' + ',' + '$2');
                  }
                  return x1 + x2;
              }

              function handleMeasurementCompleted(event) {
                  displayLayer = new OpenLayers.Layer.Vector('displayLayer');
                  tgMap.addLayer(displayLayer);

                  var parser = Map1.GetMapParser();
                  var displayLayer = parser.map.getLayersByName('displayLayer')[0];

                  var feature = new OpenLayers.Feature.Vector(event.geometry);
                  displayLayer.addFeatures([feature]);

                  //displayLayer.destroy();
                  //measureLineControl.deactivate();

                  tgMap.removeLayer(displayLayer, false);
                  measureLineControl.deactivate();
              }


    </script>
    <style type="text/css">
        #Text1
        {
            width: 63px;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <div id="Wholemap">
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
           <asp:Button ID="btnMeasureLine" runat="server" Text="Measure line" OnClientClick="javascript:activate(); return false;"/>
           <input type="button" value="Select features on map" onclick="Map1.SetDrawMode('Rectangle');return false;" 
                                            title="Draw an area on map to get feature selection" />
      <table>
          <tr>
                <td>      
                    <cc1:Map ID="Map1" runat="server" ontrackshapefinished="Map1_TrackShapeFinished" OnClientClick="AddLabel" Height="480px" Width="640px"></cc1:Map>
                </td>
                <td>
                    <asp:Panel runat="server" ID="panel"></asp:Panel>
                </td>
          </tr>
      </table>
        <div>
            <input type="button" id="btnAddEnterLabel" onclick="SetFlag()" value="AddMarker" />
            <input type="button" id="btnRemoveMarker" onclick="SetRemoveFlag()" value="RemoveMarker" />
        </div>
        <input type="hidden" id="isAddLabel" value="false" />
        <input type="hidden" id="isRemoveMarker" value="false" />    
        </ContentTemplate>
        </asp:UpdatePanel>
    </div>
    <div id="output">
    </div>
    </form>
</body>
</html>
